CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

VAR

  long  a
  long  b
  long  c
  word  s

OBJ

  print :       "format"
  tv :          "tv_wtext"
  callback :    "callback"

PUB test_print | tvout 'Procedure 1

  tv.start(12)                                          'Start tv with base pin 12.
  tvout := callback.new(@@0, 2)                         'Create a callback object that points to tv_out (procedure 2).
  print.use(tvout)                                      'Tell the print object to use tvout.
  
  a := b := c := 123                                    'Define some variables.
  s := string("This is a string.")

  'Now do some formatted printouts on tv_out.

  print.f3(string("A %d and a %d and a %d.\r"), 1,2,3)
  print.f3(string("Here's some data:\r\r  %16.2X (hex)\r  %16.1d (decimal)\r  %16.16b (binary)\r\r"), a, b, c)
  print.f2(string("Here's some more:\r\r  %5rX (repeated character)\r  \q%s\q (string)"), 10, s)

PUB tv_out(char) 'Procedure 2

  tv.out(char)
 